Index: branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdmod_oce.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdmod_oce.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdmod_oce.F90	(revision 790)
@@ -32,18 +32,36 @@
    LOGICAL , PUBLIC ::   l_trddyn = .FALSE.             !: momentum trend flag
 # endif
+#if  defined key_trdtra   &&   defined key_trddyn    ||   defined key_esopa
+   LOGICAL, PARAMETER ::   lk_trdtra = .TRUE.    !: tracers  trend flag
+   LOGICAL, PARAMETER ::   lk_trddyn = .TRUE.    !: momentum trend flag
+#elif  defined key_trdtra
+   LOGICAL, PARAMETER ::   lk_trdtra = .TRUE.    !: tracers  trend flag
+   LOGICAL, PARAMETER ::   lk_trddyn = .FALSE.   !: momentum trend flag
+#elif  defined key_trddyn
+   LOGICAL, PARAMETER ::   lk_trdtra = .FALSE.   !: tracers  trend flag
+   LOGICAL, PARAMETER ::   lk_trddyn = .TRUE.    !: momentum trend flag
+#else
+   LOGICAL, PARAMETER ::   lk_trdtra = .FALSE.   !: tracers  trend flag
+   LOGICAL, PARAMETER ::   lk_trddyn = .FALSE.   !: momentum trend flag
+#endif
+
 
    !!* Active tracers trends indexes
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_xad =  1   !: x- horizontal advection
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_yad =  2   !: y- horizontal advection
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_zad =  3   !: z- vertical   advection
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_ldf =  4   !: lateral       diffusion
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_zdf =  5   !: vertical diffusion (Kz)
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_bbc =  6   !: Bottom Boundary Condition (geoth. flux) 
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_bbl =  7   !: Bottom Boundary Layer (diffusive/convective)
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_npc =  8   !: static instability mixing
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_dmp =  9   !: damping
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_qsr = 10   !: penetrative solar radiation
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_nsr = 11   !: non solar radiation
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_atf = 12   !: Asselin correction
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd = 13        !: change it when adding/removing one indice above
+
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_xad =  1   !: x- horizontal advection
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_yad =  2   !: y- horizontal advection
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_zad =  3   !: z- vertical   advection
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_ldf =  4   !: lateral       diffusion
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_zdf =  5   !: vertical diffusion (Kz)
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_bbc =  6   !: Bottom Boundary Condition (geoth. flux) 
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_bbl =  7   !: Bottom Boundary Layer (diffusive/convective)
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_npc =  8   !: static instability mixing
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_dmp =  9   !: damping
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_qsr = 10   !: penetrative solar radiation
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_qns = 11   !: non solar heat flux
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_atf = 12   !: Asselin correction
+   INTEGER, PUBLIC, PARAMETER ::   jpt_trd_zl1 = 13   !: first level vertical flux (lk_vvl=F)
+
    
    !!* Momentum trends indexes
Index: branches/dev_001_GM/NEMO/OPA_SRC/TRD/trends_manager.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/TRD/trends_manager.F90	(revision 790)
+++ branches/dev_001_GM/NEMO/OPA_SRC/TRD/trends_manager.F90	(revision 790)
@@ -0,0 +1,14 @@
+MODULE trends_manager
+   !!======================================================================
+   !!                       ***  MODULE  trends_manager  ***
+   !! Ocean diagnostics:  ocean tracers and dynamic trends
+   !!=====================================================================
+   !! History :  9.0  !  04-08  (C. Talandier) Original code
+   !!                 !  05-04  (C. Deltel)    Add Asselin trend in the ML budget
+   !!----------------------------------------------------------------------
+#if  defined key_trdtra || defined key_trddyn || defined key_trdmld || defined key_trdvor || defined key_esopa
+
+#endif
+
+   !!======================================================================
+END MODULE trends_manager
Index: branches/dev_001_GM/NEMO/OPA_SRC/ZDF/zdfkpp.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 790)
@@ -1291,5 +1291,5 @@
          ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
 !!bug gm jpttdzdf ==> jpttkpp
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_zdf, 'TRA', kt)
+         CALL trd_mod(ztrdt, ztrds, jpt_trd_zdf, 'TRA', kt)
       ENDIF
 
Index: branches/dev_001_GM/NEMO/OPA_SRC/oce.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/oce.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/OPA_SRC/oce.F90	(revision 790)
@@ -4,17 +4,16 @@
    !! Ocean        :  dynamics and active tracers defined in memory 
    !!======================================================================
-   !! History :
-   !!   8.5  !  02-11  (G. Madec)  F90: Free form and module
-   !!   9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !! History :   1.0  !  02-11  (G. Madec)  F90: Free form and module
+   !!             2.0  !  05-11  (V. Garnier) Surface pressure gradient organization
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! NEMO/OPA 2.0 , LOCEAN-IPSL (2007) 
+   !! $Id:$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE par_oce      ! ocean parameters
 
    IMPLICIT NONE
    PRIVATE
+
 
    !! Physics and algorithm flags
@@ -23,23 +22,20 @@
    INTEGER, PUBLIC ::   nn_dynhpg_rst   = 0        !: add dynhpg implicit variables in restart ot not
 
-   !! dynamics and tracer fields
-   !! --------------------------
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-      ! before !  now      !  after  !      ! the after trends becomes the fields
-      ! fields !  fields   !  trends !      ! only in dyn(tra)_zdf and dyn(tra)_nxt
-      ub       ,  un       ,  ua     ,   &  !: i-horizontal velocity (m/s)
-      vb       ,  vn       ,  va     ,   &  !: j-horizontal velocity (m/s)
-                  wn       ,             &  !: vertical velocity (m/s)
-      rotb     ,  rotn     ,             &  !: relative vorticity (1/s)
-      hdivb    ,  hdivn    ,             &  !: horizontal divergence (1/s)
-      tb       ,  tn       ,  ta     ,   &  !: potential temperature (celcius)
-      sb       ,  sn       ,  sa            !: salinity (psu)
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-      rhd ,                              &  !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
-      rhop,                              &  !: potential volumic mass (kg/m3)
-      rn2                                   !: brunt-vaisala frequency (1/s2)
+   !! dynamics and tracer fields              ! before ! now    ! after  !   the after trends becomes the fields
+   !! --------------------------              ! fields ! fields ! trends !   only in dyn(tra)_zdf and dyn(tra)_nxt
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   ub    ,  un    ,  ua    !: i-horizontal velocity (m/s)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   vb    ,  vn    ,  va    !: j-horizontal velocity (m/s)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::            wn             !: vertical velocity (m/s)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   rotb  ,  rotn           !: relative vorticity (1/s)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   hdivb ,  hdivn          !: horizontal divergence (1/s)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   tb    ,  tn    ,  ta    !: potential temperature (celcius)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   sb    ,  sn    ,  sa    !: salinity (psu)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   rhd                     !: in situ density anomalie rhd=(rho-rau0)/rau0
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   rhop                    !: potential volumic mass (kg/m3)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   rn2                     !: brunt-vaisala frequency (1/s2)
 
       !! advection scheme choice
       !! -----------------------
+!!gm  only for trcadv...   be be suppressed
       CHARACTER(len=3), PUBLIC  ::   l_adv   !: 'ce2' centre scheme used
          !                                   !: 'tvd' TVD scheme used
@@ -49,27 +45,24 @@
    !! surface pressure gradient
    !! -------------------------
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &   !:
-      spgu, spgv             !: horizontal surface pressure gradient
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   spgu, spgv                  !: horizontal surface pressure gradient
 
    !! interpolated gradient (only used in zps case)
    !! ---------------------
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &   !:
-      gtu, gsu, gru,      &  !: t-, s- and rd horizontal gradient at u- and 
-      gtv, gsv, grv          !: v-points at bottom ocean level 
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   gtu, gsu, gru               !: t-, s- and rd horizontal gradient at u- and 
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   gtv, gsv, grv               !: v-points at bottom ocean level 
 
    !! free surface
    !! ------------
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &   !:
-      sshb , sshn ,        &  !: before, now sea surface height (meters)
-      sshu , sshv ,        &  !: sea surface height at u- and v- point
-      sshbb, ssha             !: before before sea surface height at t-point
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sshb , sshn                 !: before, now sea surface height (meters)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sshu , sshv                 !: sea surface height at u- and v- point
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sshbb, ssha                 !: before before sea surface height at t-point
 
 #if defined key_dynspg_rl   ||   defined key_esopa
    !! rigid-lid formulation
    !! ---------------------
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &   !:
-      bsfb, bsfn,         &  !: before, now barotropic streamfunction (m3/s)
-      bsfd                   !: now trend of barotropic streamfunction (m3/s2)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   bsfb, bsfn                 !: before, now barotropic streamfunction [m3/s]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   bsfd                       !: now barotropic streamfunction trend   [m3/s2]
 #endif
+
    !!----------------------------------------------------------------------
 END MODULE oce
Index: branches/dev_001_GM/NEMO/OPA_SRC/par_oce.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/par_oce.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/OPA_SRC/par_oce.F90	(revision 790)
@@ -9,5 +9,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 2.4 , LOCEAN-IPSL (2007) 
-   !! $Id:$ 
+   !! $Id$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -98,4 +98,12 @@
 #endif
 
+   !!---------------------------------------------------------------------
+   !! Temperature/salinity indices
+   !!---------------------------------------------------------------------
+
+   INTEGER, PARAMETER ::   jp_tem = 1   !: index of temperature in the tsb, tsns &, tsa arrays
+   INTEGER, PARAMETER ::   jp_sal = 2   !: index of salinity    in the tsb, tsns &, tsa arrays
+
+
    !!======================================================================
 END MODULE par_oce
Index: branches/dev_001_GM/NEMO/OPA_SRC/prtctl.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/prtctl.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/OPA_SRC/prtctl.F90	(revision 790)
@@ -1,7 +1,9 @@
 MODULE prtctl
-   !!==============================================================================
+   !!======================================================================
    !!                       ***  MODULE prtctl   ***
    !! Ocean system   : print all SUM trends for each processor domain
-   !!==============================================================================
+   !!======================================================================
+   !! History :  2.0  !  05-07  (C. Talandier) original code
+   !!----------------------------------------------------------------------
    USE dom_oce          ! ocean space and time domain variables
    USE in_out_manager   ! I/O manager
@@ -11,8 +13,6 @@
    PRIVATE
 
-   !! * Module declaration
    INTEGER, DIMENSION(:), ALLOCATABLE :: numid
-   INTEGER, DIMENSION(:), ALLOCATABLE, SAVE ::   &  !:
-      nlditl , nldjtl ,   &  !: first, last indoor index for each i-domain
+   INTEGER, DIMENSION(:), ALLOCATABLE, SAVE ::   nlditl , nldjtl ,   &  !: first, last indoor index for each i-domain
       nleitl , nlejtl ,   &  !: first, last indoor index for each j-domain
       nimpptl, njmpptl,   &  !: i-, j-indexes for each processor
@@ -20,18 +20,17 @@
       ibonitl, ibonjtl
 
-   REAL(wp), DIMENSION(:), ALLOCATABLE ::   &  !:
-      t_ctll , s_ctll ,   &  !: previous trend values
+   REAL(wp), DIMENSION(:), ALLOCATABLE ::   t_ctll , s_ctll ,   &  !: previous trend values
       u_ctll , v_ctll
 
    INTEGER ::   ktime        !: time step
 
-   !! * Routine accessibility
    PUBLIC prt_ctl         ! called by all subroutines
    PUBLIC prt_ctl_info    ! called by all subroutines
    PUBLIC prt_ctl_init    ! called by opa.F90
+
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! NEMO/OPA 2.4 , LOCEAN-IPSL (2008)
+   !! $Id:$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
    !!----------------------------------------------------------------------
 
@@ -74,9 +73,5 @@
       !!                    kdim    : k- direction for 3D arrays 
       !!                    clinfo3 : additional information 
-      !!
-      !! History :
-      !!   9.0  !  05-07  (C. Talandier) original code
-      !!----------------------------------------------------------------------
-      !! * Arguments
+      !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(:,:)  , INTENT(in), OPTIONAL :: tab2d_1
       REAL(wp), DIMENSION(:,:,:), INTENT(in), OPTIONAL :: tab3d_1
@@ -90,9 +85,8 @@
       INTEGER                   , INTENT(in), OPTIONAL :: kdim
       CHARACTER (len=*)         , INTENT(in), OPTIONAL :: clinfo3
-
-      !! * Local declarations
-      INTEGER :: overlap, jn, sind, eind, kdir,j_id
+      !!
       CHARACTER (len=15) :: cl2
-      REAL(wp) :: zsum1, zsum2, zvctl1, zvctl2
+      INTEGER  ::   overlap, jn, sind, eind, kdir,j_id
+      REAL(wp) ::   zsum1, zsum2, zvctl1, zvctl2
       REAL(wp), DIMENSION(jpi,jpj) :: ztab2d_1, ztab2d_2
       REAL(wp), DIMENSION(jpi,jpj,jpk) :: zmask1, zmask2, ztab3d_1, ztab3d_2
@@ -125,10 +119,8 @@
       IF( PRESENT(mask2)   )  zmask2  (:,:,:)= mask2  (:,:,:)
 
-      IF( lk_mpp )   THEN
-         ! processor number
+      IF( lk_mpp )   THEN      ! processor number
          sind = narea
          eind = narea
-      ELSE
-         ! processors total number
+      ELSE                     ! processors total number
          sind = 1
          eind = ijsplt
Index: branches/dev_001_GM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/step.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/OPA_SRC/step.F90	(revision 790)
@@ -4,20 +4,21 @@
    !! Time-stepping    : manager of the ocean, tracer and ice time stepping
    !!======================================================================
-   !! History :        !  91-03  ()  Original code
-   !!                  !  91-11  (G. Madec)
-   !!                  !  92-06  (M. Imbard)  add a first output record
-   !!                  !  96-04  (G. Madec)  introduction of dynspg
-   !!                  !  96-04  (M.A. Foujols)  introduction of passive tracer
-   !!             8.0  !  97-06  (G. Madec)  new architecture of call
-   !!             8.2  !  97-06  (G. Madec, M. Imbard, G. Roullet)  free surface
-   !!             8.2  !  99-02  (G. Madec, N. Grima)  hpg implicit
-   !!             8.2  !  00-07  (J-M Molines, M. Imbard)  Open Bondary Conditions
-   !!             9.0  !  02-06  (G. Madec)  free form, suppress macro-tasking
-   !!             " "  !  04-08  (C. Talandier) New trends organization
-   !!             " "  !  05-01  (C. Ethe) Add the KPP closure scheme
-   !!             " "  !  05-11  (V. Garnier) Surface pressure gradient organization
-   !!             " "  !  05-11  (G. Madec)  Reorganisation of tra and dyn calls
-   !!             " "  !  06-01  (L. Debreu, C. Mazauric)  Agrif implementation
-   !!             " "  !  06-07  (S. Masson)  restart using iom
+   !! History :        !  1991-03  ()  Original code
+   !!                  !  1991-11  (G. Madec)
+   !!                  !  1992-06  (M. Imbard)  add a first output record
+   !!                  !  1996-04  (G. Madec)  introduction of dynspg
+   !!                  !  1996-04  (M.A. Foujols)  introduction of passive tracer
+   !!             8.0  !  1997-06  (G. Madec)  new architecture of call
+   !!             8.2  !  1997-06  (G. Madec, M. Imbard, G. Roullet)  free surface
+   !!             8.2  !  1999-02  (G. Madec, N. Grima)  hpg implicit
+   !!             8.2  !  2000-07  (J-M Molines, M. Imbard)  Open Bondary Conditions
+   !!   NEMO      1.0  !  2002-06  (G. Madec)  free form, suppress macro-tasking
+   !!              -   !  2004-08  (C. Talandier) New trends organization
+   !!              -   !  2005-01  (C. Ethe) Add the KPP closure scheme
+   !!              -   !  2005-11  (V. Garnier) Surface pressure gradient organization
+   !!              -   !  2005-11  (G. Madec)  Reorganisation of tra and dyn calls
+   !!             2.0  !  2006-01  (L. Debreu, C. Mazauric)  Agrif implementation
+   !!              -   !  2006-07  (S. Masson)  restart using iom
+   !!             2.4  !  2008-01  (G. Madec) Merge TRA-TRC
    !!----------------------------------------------------------------------
    !!   stp            : OPA system time-stepping
@@ -323,5 +324,8 @@
       IF( lk_trabbl_adv  )   CALL tra_bbl_adv( kstp )       ! advective (and/or diffusive) bottom boundary layer scheme
 
-      IF( lk_tradmp      )   CALL tra_dmp    ( kstp )       ! internal damping trends
+      IF( lk_tradmp      )   THEN                           ! internal damping trends
+                             CALL tra_dmp    ( kstp, 'TRA', jp_tem, tb, ta )      ! temperature
+                             CALL tra_dmp    ( kstp, 'TRA', jp_sal, sb, sa )      ! salinity
+      ENDIF
 
                              CALL tra_adv    ( kstp )       ! horizontal & vertical advection
Index: branches/dev_001_GM/NEMO/TOP_SRC/LOBSTER/trcsed.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 790)
@@ -28,5 +28,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
-   !! $Id:$ 
+   !! $Id$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -90,4 +90,5 @@
 # endif
 # if defined key_trc_diaadd
+!!gm  bug introduced: no more mask below jpkb ! 
                trc2d(ji,jj,8) = trc2d(ji,jj,8) + ztra * fse3t(ji,jj,jk) * 86400.
 # endif
@@ -97,5 +98,5 @@
 
 #if defined key_trc_diabio
-      CALL lbc_lnk (trbio(:,:,1,8), 'T', 1. )    ! Lateral boundary conditions on trcbio
+      CALL lbc_lnk( trbio(:,:,1,8), 'T', 1. )    ! Lateral boundary conditions on trcbio
 #endif
 #if defined key_trc_diaadd
